diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dyn_gw/src/olsrd_dyn_gw.c olsrd-current/lib/dyn_gw/src/olsrd_dyn_gw.c
--- olsrd-0.5.0/lib/dyn_gw/src/olsrd_dyn_gw.c	2007-01-30 17:48:34.000000000 +0100
+++ olsrd-current/lib/dyn_gw/src/olsrd_dyn_gw.c	2007-05-09 01:49:00.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_dyn_gw.c,v 1.19 2007/01/30 16:48:34 bernd67 Exp $
+ * $Id: olsrd_dyn_gw.c,v 1.21 2007/05/08 23:49:00 bernd67 Exp $
  */
 
 /*
@@ -87,7 +87,6 @@
   void *(*Func)(void *);
   void *Arg;
 };
-
 #endif
 
 
@@ -103,8 +102,6 @@
 static struct ping_list *
 add_to_ping_list(char *, struct ping_list *);
 
-//struct ping_list *the_ping_list = NULL;
-
 struct hna_list {
   union olsr_ip_addr hna_net;
   union olsr_ip_addr hna_netmask;
@@ -121,8 +118,8 @@
 
 struct hna_list *the_hna_list = NULL;
 
-static void *
-looped_checks(void *foo);
+static void
+looped_checks(void *) __attribute__((noreturn));
 
 static int
 check_gw(union olsr_ip_addr *, union olsr_ip_addr *,struct ping_list *);
@@ -130,8 +127,9 @@
 static int
 ping_is_possible(struct ping_list *);
 
-   
-     
+/* Event function to register with the scheduler */
+static void
+olsr_event_doing_hna(void *);
 
 /**
  * read config file parameters
@@ -197,7 +195,7 @@
  *It is ran _after_ register_olsr_param
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
   pthread_t ping_thread;
   
@@ -214,7 +212,7 @@
     olsr_printf(1, "HNA Internet gateway deleted\n");
   }*/
 
-  pthread_create(&ping_thread, NULL, looped_checks, NULL);
+  pthread_create(&ping_thread, NULL, (void *(*)(void *))looped_checks, NULL);
   
   /* Register the GW check */
   olsr_register_scheduler_event(&olsr_event_doing_hna, NULL, 3, 4, NULL);
@@ -227,8 +225,8 @@
  * Scheduled event to update the hna table,
  * called from olsrd main thread to keep the hna table thread-safe
  */
-void
-olsr_event_doing_hna(void *foo)
+static void
+olsr_event_doing_hna(void *foo __attribute__((unused)))
 {
 	struct hna_list *li;
 	/*
@@ -265,76 +263,57 @@
  * reiterated every "Interval" sec (as given in the config or 
  * the default value)
  */
-static void *
-looped_checks(void *foo)
+static void
+looped_checks(void *foo __attribute__((unused)))
 {
-	/*
-	struct hna_list {
-  union olsr_ip_addr hna_net;
-  union hna_netmask hna_netmask;
-  struct ping_list *ping_hosts;
-  int hna_added;
-  int probe_ok;
-  struct hna_list *next;
-};
-	*/
-	struct hna_list *li;
-	
   for(;;) {
+    struct hna_list *li;
     struct timespec remainder_spec;
     /* the time to wait in "Interval" sec (see connfig), default=5sec */
-    struct timespec sleeptime_spec  = {(time_t) check_interval, 0L };
+    struct timespec sleeptime_spec  = { check_interval, 0L };
 
-    li=the_hna_list;
-    while(li){
-	    /* check for gw in table entry and if Ping IPs are given also do pings */
-	    li->probe_ok = check_gw(&li->hna_net,&li->hna_netmask,li->ping_hosts);
-	    //has_available_gw = check_gw(&gw_net, &gw_netmask);
-	    
-	    li=li->next;
+    for(li = the_hna_list; li; li = li->next){
+      /* check for gw in table entry and if Ping IPs are given also do pings */
+      li->probe_ok = check_gw(&li->hna_net,&li->hna_netmask,li->ping_hosts);
+      //has_available_gw = check_gw(&gw_net, &gw_netmask);
     }
 
     while(nanosleep(&sleeptime_spec, &remainder_spec) < 0)
       sleeptime_spec = remainder_spec;
   }
-  return NULL;
+  // return NULL;
 }
 
 
+
 static int
 check_gw(union olsr_ip_addr *net, union olsr_ip_addr *mask, struct ping_list *the_ping_list)
 {
-    char buff[1024], iface[16];
+    char buf[1024], iface[16];
     olsr_u32_t gate_addr, dest_addr, netmask;
     unsigned int iflags;
-    int num, metric, refcnt, use;
+    int metric, refcnt, use;
     int retval = 0;
 
     FILE *fp = fopen(PROCENTRY_ROUTE, "r");
-
     if (!fp) 
       {
         perror(PROCENTRY_ROUTE);
         olsr_printf(1, "INET (IPv4) not configured in this system.\n");
 	return -1;
-      }
-    
-    rewind(fp);
+      }    
 
     /*
     olsr_printf(1, "Genmask         Destination     Gateway         "
                 "Flags Metric Ref    Use Iface\n");
     */
-    while (fgets(buff, 1023, fp))
-	{	
-	num = sscanf(buff, "%15s %128X %128X %X %d %d %d %128X \n",
-		     iface, &dest_addr, &gate_addr,
-		     &iflags, &refcnt, &use, &metric, &netmask);
-
+    while (fgets(buf, sizeof(buf), fp))
+      {	
+	int num = sscanf(buf, "%15s %128X %128X %X %d %d %d %128X \n",
+                         iface, &dest_addr, &gate_addr,
+                         &iflags, &refcnt, &use, &metric, &netmask);
 	if (num < 8)
-	  {
 	    continue;
-	  }
 
 	/*
 	olsr_printf(1, "%-15s ", olsr_ip_to_string((union olsr_ip_addr *)&netmask));
@@ -346,33 +325,34 @@
 		    metric, refcnt, use, iface);
 	*/
 
-		if( (iflags & RTF_UP) &&
-		   (metric == 0) &&
-		   (netmask == mask->v4) && 
-		   (dest_addr == net->v4))
-		{
-			if ( ((mask->v4==INET_PREFIX)&&(net->v4==INET_NET))&&(!(iflags & RTF_GATEWAY)))
-				return retval;
-			/* don't ping, if there was no "Ping" IP addr in the config file */
-			if (the_ping_list != NULL) {  
-				/*validate the found inet gw by pinging*/ 
-				if (ping_is_possible(the_ping_list)) {
-					olsr_printf(1, "HNA[%08x/%08x](ping is possible) VIA %s detected in routing table.\n", dest_addr,netmask,iface);
-					retval=1;      
-				}
-			} else {
-				olsr_printf(1, "HNA[%08x/%08x] VIA %s detected in routing table.\n", dest_addr,netmask,iface);
-				retval=1;      
-			}
-		}
-
-	}//while
+        if( (iflags & RTF_UP) &&
+            (metric == 0) &&
+            (netmask == mask->v4) && 
+            (dest_addr == net->v4))
+          {
+            if ( ((mask->v4==INET_PREFIX)&&(net->v4==INET_NET))&&(!(iflags & RTF_GATEWAY)))
+              {
+                fclose(fp);  
+                return retval;
+              }
+            /* don't ping, if there was no "Ping" IP addr in the config file */
+            if (the_ping_list != NULL) {  
+              /*validate the found inet gw by pinging*/ 
+              if (ping_is_possible(the_ping_list)) {
+                olsr_printf(1, "HNA[%08x/%08x](ping is possible) VIA %s detected in routing table.\n", dest_addr,netmask,iface);
+                retval=1;      
+              }
+            } else {
+              olsr_printf(1, "HNA[%08x/%08x] VIA %s detected in routing table.\n", dest_addr,netmask,iface);
+              retval=1;      
+            }
+          }
+      }
 
-	fclose(fp);  
-  
-	if(retval == 0){
-		olsr_printf(1, "HNA[%08x/%08x] is invalid\n", net->v4,mask->v4);
-	}  
+    fclose(fp);      
+    if(retval == 0){
+      olsr_printf(1, "HNA[%08x/%08x] is invalid\n", net->v4,mask->v4);
+    }  
     return retval;
 }
 
@@ -380,16 +360,15 @@
 ping_is_possible(struct ping_list *the_ping_list) 
 {
   struct ping_list *list;
-  for (list = the_ping_list; list != NULL; list = list->next) {
-    char ping_command[50] = "ping -c 1 -q ";
-    strcat(ping_command, list->ping_address);
+  for(list = the_ping_list; list; list = list->next) {
+    char ping_command[50];
+    snprintf(ping_command, sizeof(ping_command), "ping -c 1 -q %s", list->ping_address);
     olsr_printf(1, "\nDo ping on %s ...\n", list->ping_address);
     if (system(ping_command) == 0) {
       olsr_printf(1, "...OK\n\n");
       return 1;      
-    } else {
-      olsr_printf(1, "...FAILED\n\n");
     }
+    olsr_printf(1, "...FAILED\n\n");
   }
   return 0;
 }
@@ -398,8 +377,8 @@
 static struct ping_list *
 add_to_ping_list(char *ping_address, struct ping_list *the_ping_list)
 {
-  struct ping_list *new = (struct ping_list *) malloc(sizeof(struct ping_list));
-  if(new == NULL)
+  struct ping_list *new = malloc(sizeof(struct ping_list));
+  if(!new)
   {
     fprintf(stderr, "DYN GW: Out of memory!\n");
     exit(0);
@@ -414,7 +393,7 @@
 static struct hna_list *
 add_to_hna_list(struct hna_list * list_root, union olsr_ip_addr *hna_net, union olsr_ip_addr *hna_netmask )
 {
-  struct hna_list *new = (struct hna_list *) malloc(sizeof(struct hna_list));
+  struct hna_list *new = malloc(sizeof(struct hna_list));
   if(new == NULL)
   {
     fprintf(stderr, "DYN GW: Out of memory!\n");
@@ -428,14 +407,10 @@
   new->probe_ok=0;
   new->ping_hosts=NULL;
   new->next=list_root;  
-
   return new;
 }
 
-
-
 #ifdef WIN32
-
 /*
  * Windows ptread compat stuff
  */
@@ -457,7 +432,7 @@
   return 0;
 }
 
-int pthread_create(HANDLE *Hand, void *Attr, void *(*Func)(void *), void *Arg)
+int pthread_create(HANDLE *Hand, void *Attr __attribute__((unused)), void *(*Func)(void *), void *Arg)
 {
   struct ThreadPara *Para;
   unsigned long ThreadId;
@@ -478,7 +453,7 @@
   return 0;
 }
 
-int pthread_kill(HANDLE Hand, int Sig)
+int pthread_kill(HANDLE Hand, int Sig __attribute__((unused)))
 {
   if (!TerminateThread(Hand, 0))
     return -1;
@@ -486,7 +461,7 @@
   return 0;
 }
 
-int pthread_mutex_init(HANDLE *Hand, void *Attr)
+int pthread_mutex_init(HANDLE *Hand, void *Attr __attribute__((unused)))
 {
   *Hand = CreateMutex(NULL, FALSE, NULL);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dyn_gw/src/olsrd_dyn_gw.h olsrd-current/lib/dyn_gw/src/olsrd_dyn_gw.h
--- olsrd-0.5.0/lib/dyn_gw/src/olsrd_dyn_gw.h	2005-05-29 14:47:40.000000000 +0200
+++ olsrd-current/lib/dyn_gw/src/olsrd_dyn_gw.h	2007-04-20 16:06:18.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_dyn_gw.h,v 1.11 2005/05/29 12:47:40 br1 Exp $
+ * $Id: olsrd_dyn_gw.h,v 1.12 2007/04/20 14:06:18 bernd67 Exp $
  */
 
 #ifndef _OLSRD_PLUGIN_TEST
@@ -50,13 +50,13 @@
 
 #define PROCENTRY_ROUTE "/proc/net/route"
 
-/* Timeout function to register with the scheduler */
-void
-olsr_timeout(void);
+int
+olsrd_plugin_init(void);
 
+int 
+olsrd_plugin_interface_version(void);
 
-/* Event function to register with the scheduler */
-void
-olsr_event_doing_hna(void *);
+int
+olsrd_plugin_register_param(char *key, char *value);
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dyn_gw/src/olsrd_plugin.c olsrd-current/lib/dyn_gw/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/dyn_gw/src/olsrd_plugin.c	2005-05-29 14:47:40.000000000 +0200
+++ olsrd-current/lib/dyn_gw/src/olsrd_plugin.c	2007-04-20 16:19:44.000000000 +0200
@@ -37,10 +37,11 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_plugin.c,v 1.12 2005/05/29 12:47:40 br1 Exp $
+ * $Id: olsrd_plugin.c,v 1.14 2007/04/20 14:19:44 bernd67 Exp $
  */
 
 #include "olsrd_plugin.h"
+#include "olsrd_dyn_gw.h"
 #include <stdio.h>
 
 #define PLUGIN_NAME    "OLSRD dynamic gateway plugin"
@@ -64,7 +65,7 @@
  * Do not alter unless you know what you are doing!
  */
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return PLUGIN_INTERFACE_VERSION;
 }
@@ -74,7 +75,7 @@
  *Constructor
  */
 void
-my_init()
+my_init(void)
 {
   /* Print plugin info to stdout */
   printf("%s\n", MOD_DESC);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/dyn_gw_plain/src/olsrd_dyn_gw_plain.c olsrd-current/lib/dyn_gw_plain/src/olsrd_dyn_gw_plain.c
--- olsrd-0.5.0/lib/dyn_gw_plain/src/olsrd_dyn_gw_plain.c	2007-02-04 21:47:50.000000000 +0100
+++ olsrd-current/lib/dyn_gw_plain/src/olsrd_dyn_gw_plain.c	2007-04-20 16:06:18.000000000 +0200
@@ -58,7 +58,7 @@
  * Used by main olsrd to check plugin interface version
  */
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return OLSRD_PLUGIN_INTERFACE_VERSION;
 }
@@ -68,7 +68,7 @@
  * Called for all plugin parameters
  */
 int
-olsrd_plugin_register_param(char *key, char *value)
+olsrd_plugin_register_param(char *key __attribute__((unused)), char *value __attribute__((unused)))
 {
   return 1;
 }
@@ -78,7 +78,7 @@
  * Called after all parameters are passed
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
   gw_net.v4 = INET_NET;
   gw_netmask.v4 = INET_PREFIX;
@@ -167,7 +167,7 @@
  * Scheduled event to update the hna table,
  * called from olsrd main thread to keep the hna table thread-safe
  */
-void olsr_event(void* foo)
+void olsr_event(void* foo __attribute__((unused)))
 {
   int res = check_gw(&gw_net, &gw_netmask);
   if (1 == res && 0 == has_inet_gateway) {
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/httpinfo/src/admin_interface.c olsrd-current/lib/httpinfo/src/admin_interface.c
--- olsrd-0.5.0/lib/httpinfo/src/admin_interface.c	2006-09-18 20:55:30.000000000 +0200
+++ olsrd-current/lib/httpinfo/src/admin_interface.c	2007-04-20 16:06:18.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: admin_interface.c,v 1.7 2006/09/18 18:55:30 kattemat Exp $
+ * $Id: admin_interface.c,v 1.8 2007/04/20 14:06:18 bernd67 Exp $
  */
 
 /*
@@ -45,26 +45,32 @@
  */
 
 
+#include "olsr.h"
 #include "olsrd_httpinfo.h"
 #include "olsr_cfg.h"
 #include "admin_html.h"
 #include "admin_interface.h"
+#include "local_hna_set.h" /* add_local_hna4_entry() */
+
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
 
+#if 0
 extern int netsprintf(char *str, const char* format, ...);
 #define sprintf netsprintf
 #define NETDIRECT
+#endif
+
 
 int
-build_admin_body(char *buf, olsr_u32_t bufsize)
+build_admin_body(char *buf, olsr_u32_t bufsize __attribute__((unused)))
 {
   int size = 0, i = 0;
 
   while(admin_frame[i] && strcmp(admin_frame[i], "<!-- BASICSETTINGS -->\n"))
     {
-      size += sprintf(&buf[size], admin_frame[i]);
+      size += snprintf(&buf[size], bufsize-size, admin_frame[i]);
       i++;
     }
   
@@ -72,69 +78,69 @@
     return size;
 
 
-  size += sprintf(&buf[size], "<tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<tr>\n");
 
-  size += sprintf(&buf[size], admin_basic_setting_int,
+  size += snprintf(&buf[size], bufsize-size, admin_basic_setting_int,
 		  "Debug level:", "debug_level", 2, olsr_cnf->debug_level);
-  size += sprintf(&buf[size], admin_basic_setting_float,
+  size += snprintf(&buf[size], bufsize-size, admin_basic_setting_float,
 		  "Pollrate:", "pollrate", 4, olsr_cnf->pollrate);
-  size += sprintf(&buf[size], admin_basic_setting_string,
+  size += snprintf(&buf[size], bufsize-size, admin_basic_setting_string,
 		  "TOS:", "tos", 6, "TBD");
 
-  size += sprintf(&buf[size], "</tr>\n");
-  size += sprintf(&buf[size], "<tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<tr>\n");
 
-  size += sprintf(&buf[size], admin_basic_setting_int,
+  size += snprintf(&buf[size], bufsize-size, admin_basic_setting_int,
 		  "TC redundancy:", "tc_redundancy", 1, olsr_cnf->tc_redundancy);
-  size += sprintf(&buf[size], admin_basic_setting_int,
+  size += snprintf(&buf[size], bufsize-size, admin_basic_setting_int,
 		  "MPR coverage:", "mpr_coverage", 1, olsr_cnf->mpr_coverage);
-  size += sprintf(&buf[size], admin_basic_setting_int,
+  size += snprintf(&buf[size], bufsize-size, admin_basic_setting_int,
 		  "Willingness:", "willingness", 1, olsr_cnf->willingness);
 
-  size += sprintf(&buf[size], "</tr>\n");
-  size += sprintf(&buf[size], "<tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<tr>\n");
 
   if(olsr_cnf->use_hysteresis)
     {
-      size += sprintf(&buf[size], admin_basic_setting_float,
+      size += snprintf(&buf[size], bufsize-size, admin_basic_setting_float,
 		      "Hyst scaling:", "hyst_scaling", 4, olsr_cnf->hysteresis_param.scaling);
 
-      size += sprintf(&buf[size], admin_basic_setting_float,
+      size += snprintf(&buf[size], bufsize-size, admin_basic_setting_float,
 		      "Lower thr:", "hyst_lower", 4, olsr_cnf->hysteresis_param.thr_low);
-      size += sprintf(&buf[size], admin_basic_setting_float,
+      size += snprintf(&buf[size], bufsize-size, admin_basic_setting_float,
 		      "Upper thr:", "hyst_upper", 4, olsr_cnf->hysteresis_param.thr_high);
     }
   else
     {
-      size += sprintf(&buf[size], "<td>Hysteresis disabled</td>\n");
+      size += snprintf(&buf[size], bufsize-size, "<td>Hysteresis disabled</td>\n");
     }
 
-  size += sprintf(&buf[size], "</tr>\n");
-  size += sprintf(&buf[size], "<tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<tr>\n");
   
   if(olsr_cnf->lq_level)
     {
-      size += sprintf(&buf[size], admin_basic_setting_int,
+      size += snprintf(&buf[size], bufsize-size, admin_basic_setting_int,
 		      "LQ level:", "lq_level", 1, olsr_cnf->lq_level);
-      size += sprintf(&buf[size], admin_basic_setting_int,
+      size += snprintf(&buf[size], bufsize-size, admin_basic_setting_int,
 		      "LQ winsize:", "lq_wsize", 2, olsr_cnf->lq_wsize);
     }
   else
     {
-      size += sprintf(&buf[size], "<td>LQ disabled</td>\n");
+      size += snprintf(&buf[size], bufsize-size, "<td>LQ disabled</td>\n");
     }
 
 
-  size += sprintf(&buf[size], "</tr>\n");
-  size += sprintf(&buf[size], "<tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "<tr>\n");
 
-  size += sprintf(&buf[size], "</tr>\n");
+  size += snprintf(&buf[size], bufsize-size, "</tr>\n");
   
   i++;
 
   while(admin_frame[i] && strcmp(admin_frame[i], "<!-- HNAENTRIES -->\n"))
     {
-      size += sprintf(&buf[size], admin_frame[i]);
+      size += snprintf(&buf[size], bufsize-size, admin_frame[i]);
       i++;
     }
 
@@ -149,7 +155,7 @@
       
       for(hna4 = olsr_cnf->hna4_entries; hna4; hna4 = hna4->next)
 	{
-	  size += sprintf(&buf[size], admin_frame[i], 
+	  size += snprintf(&buf[size], bufsize-size, admin_frame[i], 
 			  olsr_ip_to_string((union olsr_ip_addr *)&hna4->net),
 			  olsr_ip_to_string((union olsr_ip_addr *)&hna4->netmask),
 			  olsr_ip_to_string((union olsr_ip_addr *)&hna4->net),
@@ -162,7 +168,7 @@
 	
       for(hna6 = olsr_cnf->hna6_entries; hna6; hna6 = hna6->next)
 	{
-	  size += sprintf(&buf[size], admin_frame[i], 
+	  size += snprintf(&buf[size], bufsize-size, admin_frame[i], 
 			  olsr_ip_to_string((union olsr_ip_addr *)&hna6->net),
 			  "TBD"/*hna6->prefix_len*/);
 	}
@@ -172,7 +178,7 @@
 
   while(admin_frame[i])
     {
-      size += sprintf(&buf[size], admin_frame[i]);
+      size += snprintf(&buf[size], bufsize-size, admin_frame[i]);
       i++;
     }
   
@@ -334,7 +340,7 @@
 	  return -1;
 	}
       add_local_hna4_entry((union olsr_ip_addr *)&curr_hna_net,
-			   (union hna_netmask *)&in.s_addr);
+			   (union olsr_ip_addr *)&in.s_addr);
       
       return 1;
     }
@@ -366,7 +372,7 @@
 	}
 
       remove_local_hna4_entry((union olsr_ip_addr *)&net.s_addr,
-			      (union hna_netmask *)&mask.s_addr);
+			      (union olsr_ip_addr *)&mask.s_addr);
 
       return 1;
     }
@@ -378,10 +384,11 @@
 }
 
 int
-process_set_values(char *data, olsr_u32_t data_size, char *buf, olsr_u32_t bufsize)
+process_set_values(char *data, olsr_u32_t data_size, char *buf, olsr_u32_t bufsize __attribute__((unused)))
 {
   int size = 0;
-  int i, val_start, key_start;
+  int val_start, key_start;
+  olsr_u32_t i;
 
   printf("Dynamic Data: %s\n", data);
 
@@ -403,7 +410,7 @@
 	  data[i] = '\0';
 	  if(!process_param(&data[key_start], &data[val_start]))
 	    {
-	      size += sprintf(&buf[size], "<h2>FAILED PROCESSING!</h2><br>Key: %s Value: %s<br>\n", 
+	      size += snprintf(&buf[size], bufsize-size, "<h2>FAILED PROCESSING!</h2><br>Key: %s Value: %s<br>\n", 
 			      &data[key_start], &data[val_start]);
 	      return -1;
 	    }
@@ -416,7 +423,7 @@
 
   if(!process_param(&data[key_start], &data[val_start]))
     {
-      size += sprintf(&buf[size], "<b>FAILED PROCESSING!</b><br>Key: %s Value: %s<br>\n", 
+      size += snprintf(&buf[size], bufsize-size, "<b>FAILED PROCESSING!</b><br>Key: %s Value: %s<br>\n", 
 		      &data[key_start], &data[val_start]);
       return -1;
     }
@@ -424,8 +431,8 @@
   printf("Key: %s\nValue: %s\n", 
 	 &data[key_start], &data[val_start]);
 
-  size += sprintf(&buf[size], "<h2>UPDATE SUCESSFULL!</h2><br>Press BACK and RELOAD in your browser to return to the plugin<br>\n</body>\n</html>\n");
-  size += sprintf(&buf[size], "\n</body>\n</html>\n");
+  size += snprintf(&buf[size], bufsize-size, "<h2>UPDATE SUCESSFULL!</h2><br>Press BACK and RELOAD in your browser to return to the plugin<br>\n</body>\n</html>\n");
+  size += snprintf(&buf[size], bufsize-size, "\n</body>\n</html>\n");
 
   return size;
 }
